/* grav.h */

/*
 * Include file for gravity module of hierarchical N-body code.  Defines 
 *   its prototypes.
 *
 * Modified By:  Joe Hummel, UC-Irvine, 1992
 *
 * Original Author:
 * Copyright (c) 1991, Joshua E. Barnes, Honolulu, HI.
 * 	    It's free because it's yours.
 */


#ifndef GRAV_H  /* prevent multiple includes */
#define GRAV_H

/*
 * Prototypes
 */
 
void hackgrav(NodePtr_t p);

/*
 * Local prototypes...
 */

local void gravsub(NodePtr_t p);
local void hackwalk(void);
local void walksub(NodePtr_t p, real dsq);
local bool subdivp(NodePtr_t p, real dsq);

#endif
